# MOST OF THIS SCRIPT IS DEPRECATED AND SHOULD BE REMOVED
#!/bin/bash

#$2 - Action: SET\RESET

# stop operation if an error occurred
set -e

# port number constant is replaced by tcr/tma config
DEFAULT_PORTS=(22)
CONFIGURED_PORTS=
LISTEN_ADDRESS=
SERVICE="tcr"
DIR="/opt/tcr"

#ports must be specified before ListenAddress
function set_listen_address {
    if [ "$SERVICE" == "tcr" -a "`readlink -f /opt/tcr`" == "$DIR" ]; then
        #Remove any ListenAddress lines (to avoid duplicates)
        sed -i "/^ListenAddress .*/d" /etc/ssh/sshd_config

      if [ ! -z $LISTEN_ADDRESS ]; then
          #add ListenAddress line
          echo -e "ListenAddress $LISTEN_ADDRESS" >>  /etc/ssh/sshd_config
      fi
    fi
}

function set_ssh_ports {
    action="-j ACCEPT"
    comment="-m comment --comment \"managed by set_ssh_port\.sh\""
    ports=""
    for i in  "${CONFIGURED_PORTS[@]}"; do
        echo -e "Port $i" >>  /etc/ssh/sshd_config
        ports="$i,$ports"
    done
    ports="${ports::-1}"
    rule="-A INPUT -p tcp -m multiport --dports $ports $comment $action"
    sed -i "s/.*$comment.*/$rule/g" tcr_iptables_default_policy
    if [ "${TCR_RUNNING}" = "0" ] ; then
        ./iptables/iptables-restore < tcr_iptables_default_policy
    fi
}


SERVICE=$1 # usage for TMA is DEPRECATED
DIR=$2
ACTION=$3

if [ "$SERVICE" != "tcr" -a "$SERVICE" != "tma" ]; then
    echo "[Set SSH Port]: Bad type. The first argument should be 'tma' or 'tcr'."
    exit
fi

if [ "$SERVICE" == "tcr" -a "`readlink -f /opt/tcr`" == "$DIR" ] && [ "$ACTION" == "SET_PORTS" -o "$ACTION" == "RESET" ]; then
#remove all current entries in sshd_config (and actually leave it with no config = default = 22)
sed -i "/^Port .*/d" /etc/ssh/sshd_config

#disable ipv6
#Remove any AddressFamily lines (to avoid duplicates)
sed -i "/^AddressFamily .*/d" /etc/ssh/sshd_config
#add AddressFamily line only for ipv4
  if [ -z "$(tail -c 1 "/etc/ssh/sshd_config")" ]
    then
        echo -e "AddressFamily inet" >>  /etc/ssh/sshd_config
    else
        echo -e "\nAddressFamily inet" >>  /etc/ssh/sshd_config
  fi
fi

if [ "$ACTION" == "SET_PORTS" ]; then
    CONFIGURED_PORTS=($4)
    TCR_RUNNING=$5
    LISTEN_ADDRESS=$6
    set_ssh_ports
    set_listen_address
elif [ "$ACTION" == "RESET" ]; then
    CONFIGURED_PORTS=("${DEFAULT_PORTS[@]}")
    ACL_IPS=()
    LISTEN_ADDRESS=
    set_listen_address
else
    echo "[Set SSH Port]: Bad Action"
    exit
fi

if [ "$SERVICE" == "tcr" -a "`readlink -f /opt/tcr`" == "$DIR" ] && [ "$ACTION" == "SET_PORTS" -o "$ACTION" == "RESET" ]; then
    #stop ssh service
    service sshd stop
    #kill all sshd listening processes
    ss -tulpn4 | grep -w sshd | awk -F '[/, ]+' '{ print $8 }' | while IFS= read -r line; do
        echo Killing process $line
        kill -9 $line 
    done
    #start ssh service
    service sshd start
fi

